# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers seeking to innovate with Ingram Micro's API solutions, automate your eCommerce experience with our array of API's and webhooks to craft a seamless journey for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PriceAndAvailabilityRequestAvailabilityByWarehouseInner(BaseModel):
    """
    PriceAndAvailabilityRequestAvailabilityByWarehouseInner
    """ # noqa: E501
    availability_by_warehouse_id: Optional[StrictStr] = Field(default=None, description="Plant/warehouse Id of a particular location in order to get just the inventory of that location.", alias="availabilityByWarehouseId")
    availability_for_all_location: Optional[StrictBool] = Field(default=None, description="Pass boolean value as input, if true the response will contain warehouse location details, if false the response will not hold warehouse location details. By default value is true.", alias="availabilityForAllLocation")
    __properties: ClassVar[List[str]] = ["availabilityByWarehouseId", "availabilityForAllLocation"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PriceAndAvailabilityRequestAvailabilityByWarehouseInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if availability_by_warehouse_id (nullable) is None
        # and model_fields_set contains the field
        if self.availability_by_warehouse_id is None and "availability_by_warehouse_id" in self.model_fields_set:
            _dict['availabilityByWarehouseId'] = None

        # set to None if availability_for_all_location (nullable) is None
        # and model_fields_set contains the field
        if self.availability_for_all_location is None and "availability_for_all_location" in self.model_fields_set:
            _dict['availabilityForAllLocation'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PriceAndAvailabilityRequestAvailabilityByWarehouseInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "availabilityByWarehouseId": obj.get("availabilityByWarehouseId"),
            "availabilityForAllLocation": obj.get("availabilityForAllLocation")
        })
        return _obj


