# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers seeking to innovate with Ingram Micro's API solutions, automate your eCommerce experience with our array of API's and webhooks to craft a seamless journey for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from xi.sdk.resellers.models.price_and_availability_response_inner_availability_availability_by_warehouse_inner import PriceAndAvailabilityResponseInnerAvailabilityAvailabilityByWarehouseInner
from typing import Optional, Set
from typing_extensions import Self

class PriceAndAvailabilityResponseInnerAvailability(BaseModel):
    """
    PriceAndAvailabilityResponseInnerAvailability
    """ # noqa: E501
    available: Optional[StrictBool] = Field(default=None, description="Boolean that indicates if the product ordered is available")
    total_availability: Optional[StrictInt] = Field(default=None, description="The total amount of available products", alias="totalAvailability")
    availability_by_warehouse: Optional[List[PriceAndAvailabilityResponseInnerAvailabilityAvailabilityByWarehouseInner]] = Field(default=None, alias="availabilityByWarehouse")
    __properties: ClassVar[List[str]] = ["available", "totalAvailability", "availabilityByWarehouse"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PriceAndAvailabilityResponseInnerAvailability from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in availability_by_warehouse (list)
        _items = []
        if self.availability_by_warehouse:
            for _item_availability_by_warehouse in self.availability_by_warehouse:
                if _item_availability_by_warehouse:
                    _items.append(_item_availability_by_warehouse.to_dict())
            _dict['availabilityByWarehouse'] = _items
        # set to None if total_availability (nullable) is None
        # and model_fields_set contains the field
        if self.total_availability is None and "total_availability" in self.model_fields_set:
            _dict['totalAvailability'] = None

        # set to None if availability_by_warehouse (nullable) is None
        # and model_fields_set contains the field
        if self.availability_by_warehouse is None and "availability_by_warehouse" in self.model_fields_set:
            _dict['availabilityByWarehouse'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PriceAndAvailabilityResponseInnerAvailability from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "available": obj.get("available"),
            "totalAvailability": obj.get("totalAvailability"),
            "availabilityByWarehouse": [PriceAndAvailabilityResponseInnerAvailabilityAvailabilityByWarehouseInner.from_dict(_item) for _item in obj["availabilityByWarehouse"]] if obj.get("availabilityByWarehouse") is not None else None
        })
        return _obj


