# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers seeking to innovate with Ingram Micro's API solutions, automate your eCommerce experience with our array of API's and webhooks to craft a seamless journey for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PriceAndAvailabilityResponseInnerReserveInventoryDetailsInner(BaseModel):
    """
    PriceAndAvailabilityResponseInnerReserveInventoryDetailsInner
    """ # noqa: E501
    quantity_reserved: Optional[StrictInt] = Field(default=None, description="The quantity of the product reserved for the customer.", alias="quantityReserved")
    quantity_available: Optional[StrictInt] = Field(default=None, description="The availability of the product reserved.", alias="quantityAvailable")
    effectivedate: Optional[StrictStr] = Field(default=None, description="The reservation date for the product in UTC format.")
    expirydate: Optional[StrictStr] = Field(default=None, description="The expiration date for the reservation of the product in UTC format.")
    __properties: ClassVar[List[str]] = ["quantityReserved", "quantityAvailable", "effectivedate", "expirydate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PriceAndAvailabilityResponseInnerReserveInventoryDetailsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if quantity_reserved (nullable) is None
        # and model_fields_set contains the field
        if self.quantity_reserved is None and "quantity_reserved" in self.model_fields_set:
            _dict['quantityReserved'] = None

        # set to None if quantity_available (nullable) is None
        # and model_fields_set contains the field
        if self.quantity_available is None and "quantity_available" in self.model_fields_set:
            _dict['quantityAvailable'] = None

        # set to None if effectivedate (nullable) is None
        # and model_fields_set contains the field
        if self.effectivedate is None and "effectivedate" in self.model_fields_set:
            _dict['effectivedate'] = None

        # set to None if expirydate (nullable) is None
        # and model_fields_set contains the field
        if self.expirydate is None and "expirydate" in self.model_fields_set:
            _dict['expirydate'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PriceAndAvailabilityResponseInnerReserveInventoryDetailsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "quantityReserved": obj.get("quantityReserved"),
            "quantityAvailable": obj.get("quantityAvailable"),
            "effectivedate": obj.get("effectivedate"),
            "expirydate": obj.get("expirydate")
        })
        return _obj


