# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers seeking to innovate with Ingram Micro's API solutions, automate your eCommerce experience with our array of API's and webhooks to craft a seamless journey for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from xi.sdk.resellers.models.product_detail_response_additional_information import ProductDetailResponseAdditionalInformation
from xi.sdk.resellers.models.product_detail_response_cisco_fields import ProductDetailResponseCiscoFields
from xi.sdk.resellers.models.product_detail_response_indicators import ProductDetailResponseIndicators
from xi.sdk.resellers.models.product_detail_response_subscription_details_inner import ProductDetailResponseSubscriptionDetailsInner
from typing import Optional, Set
from typing_extensions import Self

class ProductDetailResponse(BaseModel):
    """
    ProductDetailResponse
    """ # noqa: E501
    ingram_part_number: Optional[StrictStr] = Field(default=None, description="Ingram Micro unique part number for the product.", alias="ingramPartNumber")
    vendor_part_number: Optional[StrictStr] = Field(default=None, description="Vendor’s part number for the product.", alias="vendorPartNumber")
    product_authorized: Optional[StrictStr] = Field(default=None, description="Boolean that indicates whether a product is authorized.", alias="productAuthorized")
    description: Optional[StrictStr] = Field(default=None, description="The description given for the product.")
    upc: Optional[StrictStr] = Field(default=None, description="The UPC code for the product. Consists of 12 numeric digits that are uniquely assigned to each trade item.")
    product_category: Optional[StrictStr] = Field(default=None, description="The category of the product.", alias="productCategory")
    product_subcategory: Optional[StrictStr] = Field(default=None, description="The sub-category of the product.", alias="productSubcategory")
    vendor_name: Optional[StrictStr] = Field(default=None, description="Vendor name for the order.", alias="vendorName")
    vendor_number: Optional[StrictStr] = Field(default=None, description="Vendor number that identifies the product.", alias="vendorNumber")
    product_status_code: Optional[StrictStr] = Field(default=None, description="Status code of the product.", alias="productStatusCode")
    product_class: Optional[StrictStr] = Field(default=None, description="Indicates whether the product is directly shipped from the vendor’s warehouse or if the product ships from Ingram Micro’s warehouse. Class Codes are Ingram classifications on how skus are stocked A = Product that is stocked usually in all IM warehouses and replenished on a regular basis. B = Product that is stocked in limited IM warehouses and replenished on a regular basis C = Product that is stocked in fewer IM warehouses and replenished on a regular basis. D = Product that Ingram Micro has elected to discontinue. E = Product that will be phased out later, according to the vendor. You may not want to replenish this product, but instead sell down what is in stock. F = Product that we carry for a specific customer or supplier under a contractual agreement. N = New Sku. Classification before first receipt O = Discontinued product to be liquidated S= Order for Specialized Demand (Order to backorder) X= direct ship from Vendor V = product that vendor has elected to discontinue.", alias="productClass")
    customer_part_number: Optional[StrictStr] = Field(default=None, description="Reseller / end-user’s part number for the product.", alias="customerPartNumber")
    indicators: Optional[ProductDetailResponseIndicators] = None
    cisco_fields: Optional[ProductDetailResponseCiscoFields] = Field(default=None, alias="ciscoFields")
    warranty_information: Optional[List[Dict[str, Any]]] = Field(default=None, description="Warranty information related to the product.", alias="warrantyInformation")
    additional_information: Optional[ProductDetailResponseAdditionalInformation] = Field(default=None, alias="additionalInformation")
    subscription_details: Optional[List[ProductDetailResponseSubscriptionDetailsInner]] = Field(default=None, description="Subscription product Details", alias="subscriptionDetails")
    __properties: ClassVar[List[str]] = ["ingramPartNumber", "vendorPartNumber", "productAuthorized", "description", "upc", "productCategory", "productSubcategory", "vendorName", "vendorNumber", "productStatusCode", "productClass", "customerPartNumber", "indicators", "ciscoFields", "warrantyInformation", "additionalInformation", "subscriptionDetails"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProductDetailResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of indicators
        if self.indicators:
            _dict['indicators'] = self.indicators.to_dict()
        # override the default output from pydantic by calling `to_dict()` of cisco_fields
        if self.cisco_fields:
            _dict['ciscoFields'] = self.cisco_fields.to_dict()
        # override the default output from pydantic by calling `to_dict()` of additional_information
        if self.additional_information:
            _dict['additionalInformation'] = self.additional_information.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in subscription_details (list)
        _items = []
        if self.subscription_details:
            for _item_subscription_details in self.subscription_details:
                if _item_subscription_details:
                    _items.append(_item_subscription_details.to_dict())
            _dict['subscriptionDetails'] = _items
        # set to None if ingram_part_number (nullable) is None
        # and model_fields_set contains the field
        if self.ingram_part_number is None and "ingram_part_number" in self.model_fields_set:
            _dict['ingramPartNumber'] = None

        # set to None if vendor_part_number (nullable) is None
        # and model_fields_set contains the field
        if self.vendor_part_number is None and "vendor_part_number" in self.model_fields_set:
            _dict['vendorPartNumber'] = None

        # set to None if product_authorized (nullable) is None
        # and model_fields_set contains the field
        if self.product_authorized is None and "product_authorized" in self.model_fields_set:
            _dict['productAuthorized'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if upc (nullable) is None
        # and model_fields_set contains the field
        if self.upc is None and "upc" in self.model_fields_set:
            _dict['upc'] = None

        # set to None if product_category (nullable) is None
        # and model_fields_set contains the field
        if self.product_category is None and "product_category" in self.model_fields_set:
            _dict['productCategory'] = None

        # set to None if product_subcategory (nullable) is None
        # and model_fields_set contains the field
        if self.product_subcategory is None and "product_subcategory" in self.model_fields_set:
            _dict['productSubcategory'] = None

        # set to None if vendor_name (nullable) is None
        # and model_fields_set contains the field
        if self.vendor_name is None and "vendor_name" in self.model_fields_set:
            _dict['vendorName'] = None

        # set to None if vendor_number (nullable) is None
        # and model_fields_set contains the field
        if self.vendor_number is None and "vendor_number" in self.model_fields_set:
            _dict['vendorNumber'] = None

        # set to None if product_status_code (nullable) is None
        # and model_fields_set contains the field
        if self.product_status_code is None and "product_status_code" in self.model_fields_set:
            _dict['productStatusCode'] = None

        # set to None if product_class (nullable) is None
        # and model_fields_set contains the field
        if self.product_class is None and "product_class" in self.model_fields_set:
            _dict['productClass'] = None

        # set to None if customer_part_number (nullable) is None
        # and model_fields_set contains the field
        if self.customer_part_number is None and "customer_part_number" in self.model_fields_set:
            _dict['customerPartNumber'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProductDetailResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ingramPartNumber": obj.get("ingramPartNumber"),
            "vendorPartNumber": obj.get("vendorPartNumber"),
            "productAuthorized": obj.get("productAuthorized"),
            "description": obj.get("description"),
            "upc": obj.get("upc"),
            "productCategory": obj.get("productCategory"),
            "productSubcategory": obj.get("productSubcategory"),
            "vendorName": obj.get("vendorName"),
            "vendorNumber": obj.get("vendorNumber"),
            "productStatusCode": obj.get("productStatusCode"),
            "productClass": obj.get("productClass"),
            "customerPartNumber": obj.get("customerPartNumber"),
            "indicators": ProductDetailResponseIndicators.from_dict(obj["indicators"]) if obj.get("indicators") is not None else None,
            "ciscoFields": ProductDetailResponseCiscoFields.from_dict(obj["ciscoFields"]) if obj.get("ciscoFields") is not None else None,
            "warrantyInformation": obj.get("warrantyInformation"),
            "additionalInformation": ProductDetailResponseAdditionalInformation.from_dict(obj["additionalInformation"]) if obj.get("additionalInformation") is not None else None,
            "subscriptionDetails": [ProductDetailResponseSubscriptionDetailsInner.from_dict(_item) for _item in obj["subscriptionDetails"]] if obj.get("subscriptionDetails") is not None else None
        })
        return _obj


