# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers seeking to innovate with Ingram Micro's API solutions, automate your eCommerce experience with our array of API's and webhooks to craft a seamless journey for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from xi.sdk.resellers.models.product_detail_response_additional_information_product_weight_inner import ProductDetailResponseAdditionalInformationProductWeightInner
from typing import Optional, Set
from typing_extensions import Self

class ProductDetailResponseAdditionalInformation(BaseModel):
    """
    Additional Information related to the product.
    """ # noqa: E501
    product_weight: Optional[List[ProductDetailResponseAdditionalInformationProductWeightInner]] = Field(default=None, description="Weight information related to the product.", alias="productWeight")
    is_bulk_freight: Optional[StrictBool] = Field(default=None, description="Example : true or false", alias="isBulkFreight")
    height: Optional[StrictStr] = Field(default=None, description="Example : '5.2 Inches'")
    width: Optional[StrictStr] = Field(default=None, description="Example : '13 inches'")
    length: Optional[StrictStr] = Field(default=None, description="Example : '20.4 inches'")
    net_weight: Optional[StrictStr] = Field(default=None, description="Example : '10 lb'", alias="netWeight")
    dimension_unit: Optional[StrictStr] = Field(default=None, description="Example : 'Unit value'", alias="dimensionUnit")
    __properties: ClassVar[List[str]] = ["productWeight", "isBulkFreight", "height", "width", "length", "netWeight", "dimensionUnit"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProductDetailResponseAdditionalInformation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in product_weight (list)
        _items = []
        if self.product_weight:
            for _item_product_weight in self.product_weight:
                if _item_product_weight:
                    _items.append(_item_product_weight.to_dict())
            _dict['productWeight'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProductDetailResponseAdditionalInformation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "productWeight": [ProductDetailResponseAdditionalInformationProductWeightInner.from_dict(_item) for _item in obj["productWeight"]] if obj.get("productWeight") is not None else None,
            "isBulkFreight": obj.get("isBulkFreight"),
            "height": obj.get("height"),
            "width": obj.get("width"),
            "length": obj.get("length"),
            "netWeight": obj.get("netWeight"),
            "dimensionUnit": obj.get("dimensionUnit")
        })
        return _obj


