# coding: utf-8

"""
    XI Sdk Resellers

    For Resellers seeking to innovate with Ingram Micro's API solutions, automate your eCommerce experience with our array of API's and webhooks to craft a seamless journey for your customers.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from xi.sdk.resellers.models.product_search_response_subscription_catalog_inner_plans_inner import ProductSearchResponseSubscriptionCatalogInnerPlansInner
from typing import Optional, Set
from typing_extensions import Self

class ProductSearchResponseSubscriptionCatalogInner(BaseModel):
    """
    ProductSearchResponseSubscriptionCatalogInner
    """ # noqa: E501
    group_name: Optional[StrictStr] = Field(default=None, description="The name of the group. (The info will shown if searched with showGroupInfo=true)", alias="groupName")
    group_description: Optional[StrictStr] = Field(default=None, description="The description of the group. (The info will shown if searched with showGroupInfo=true)", alias="groupDescription")
    number_of_plans: Optional[StrictStr] = Field(default=None, description="The number of plans available for the group. (The info will shown if searched with showGroupInfo=true)", alias="numberOfPlans")
    link: Optional[StrictStr] = Field(default=None, description="URL to access more details about the group. (The info will shown if searched with showGroupInfo=true)")
    plans: Optional[List[ProductSearchResponseSubscriptionCatalogInnerPlansInner]] = None
    __properties: ClassVar[List[str]] = ["groupName", "groupDescription", "numberOfPlans", "link", "plans"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProductSearchResponseSubscriptionCatalogInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in plans (list)
        _items = []
        if self.plans:
            for _item_plans in self.plans:
                if _item_plans:
                    _items.append(_item_plans.to_dict())
            _dict['plans'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProductSearchResponseSubscriptionCatalogInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "groupName": obj.get("groupName"),
            "groupDescription": obj.get("groupDescription"),
            "numberOfPlans": obj.get("numberOfPlans"),
            "link": obj.get("link"),
            "plans": [ProductSearchResponseSubscriptionCatalogInnerPlansInner.from_dict(_item) for _item in obj["plans"]] if obj.get("plans") is not None else None
        })
        return _obj


